﻿/*
		com.roytanck.wpcumulus.Tag
		Copyright 2008: Roy Tanck 
		
		This file is part of WP-Cumulus.

    WP-Cumulus is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

package com.roytanck.wpcumulus
{
	import flash.display.Sprite;
	//import flash.display.Shape;
	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.events.Event;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.events.MouseEvent;
	import flash.net.navigateToURL;
	import flash.net.URLRequest;
	import flash.display.Graphics;
	import com.roytanck.wpcumulus.Converter;
	//import flash.display.BlendMode;
	
	public class Tag extends Sprite {
		
		//private var _tf:TextField;
		private var _back:Sprite;
		private var _node:XML;
		private var _cx:Number;
		private var _cy:Number;
		private var _cz:Number;
		
		public function Tag( node:XML ){
			_node = node;
			//this.blendMode = BlendMode.LIGHTEN;
			// create the text field
			var tf:TextField = new TextField();
			tf.autoSize = TextFieldAutoSize.LEFT;
			tf.selectable = false;
			// set styles
			var format:TextFormat = new TextFormat();
			format.font = "Arial";
			format.bold = true;
			format.color = 0xffffff;
			format.size = 2 * getNumberFromString( node["@style"] );
			tf.defaultTextFormat = format;
			tf.embedFonts = true;
			// set text
			tf.text = node;
			var hb:Converter = new Converter(tf.text);
			hb.conv();
			tf.text = hb.getString();
			addChild(tf);
			// scale and add
			tf.x = -this.width / 2;
			tf.y = -this.height / 2;
			// create the back
			_back = new Sprite();
			_back.graphics.beginFill(0x000000, 0);
			_back.graphics.lineStyle(0, 0xffffff);
			_back.graphics.drawRect(0, 0, tf.textWidth+20, tf.textHeight+5);
			_back.graphics.endFill();
			addChild(_back);
			_back.x = -(tf.textWidth/2) - 10;
			_back.y = -(tf.textHeight/2) - 2;
			_back.visible = false;
			// events
			this.buttonMode = true;
			addEventListener(MouseEvent.MOUSE_OUT, mouseOutHandler);
			addEventListener(MouseEvent.MOUSE_OVER, mouseOverHandler);
			addEventListener(MouseEvent.MOUSE_UP, mouseUpHandler);
		}
		
		private function mouseOverHandler( e:MouseEvent ):void {
			_back.visible = true;
		}
		
		private function mouseOutHandler( e:MouseEvent ):void {
			_back.visible = false;
		}
		
		private function mouseUpHandler( e:MouseEvent ):void {
			var request:URLRequest = new URLRequest( _node["@href"] );
			navigateToURL(request,"_self");
		}

		private function getNumberFromString( s:String ):Number {
			return( Number( s.match( /(\d|\.)/g ).join("") ) );
			/*
			var validChars:String = "0123456789.";
			var output:String = "";
			for( var i:Number=0; i<s.length; i++ ){
				if( validChars.indexOf( s.substr(i,1) ) != -1 ){
					output += s.substr(i,1);
				}
			}
			return( Number( output ) );
			*/
		}
		
		// setters and getters
		public function set cx( n:Number ){ _cx = n }
		public function get cx():Number { return _cx; }
		public function set cy( n:Number ){ _cy = n }
		public function get cy():Number { return _cy; }
		public function set cz( n:Number ){ _cz = n }
		public function get cz():Number { return _cz; }

	}

}
